Subject: bug#22506: make change-history now doesn't work at all

From: Paul Eggert <[email-masked]>
Date: Sun, 31 Jan 2016 12:53:46 -0800

Glenn Morris wrote:
> Package: emacs
> Version: 25.0.90
>
> I don't know how y'all plan to address the issue of running make
> change-history on the release branch (bug#21998), but now it doesn't
> work on either emacs-25 or master. On both branches,
> change-history-nocommit fails with "fatal: Invalid revision range".

I reproduced the problem and installed the attached patches to the emacs-25 and 
master branches to try to fix it.

In the master branch this problem was introduced by my commit 
ffbf163ab5ced1bc464a0034e6abc9a41f5e09c4 dated Sat Jan 30 14:45:53 2016 -0800. I 
did this commit by hand, not by using 'make change-history', and evidently I 
messed it up.

In the emacs-25 branch this problem was introduced by Nicolas Petton's commit 
e6b7b6d89ff9288a49099f041752908b5eb9613e dated Sat Jan 30 14:39:23 2016 +0100, 
which updated ChangeLog.2's end commit from 
8a8613bcf4227dfe46a694b761e9575bdf6ca2ce (by me dated Sat Nov 7 23:52:17 2015 
-0800) to d5195155f9a297dc45a40c9b7175715ffe4f1612 (a commit ID that does not 
exist in the Emacs repository). My guess is that Nicolas ran 'make 
change-history' on a private branch and then merged the result into emacs-25. 
This has never worked, and it's why Makefile.in tries to check for this sort of 
thing. I vaguely recall telling Nicolas to ignore the checks and do the right 
thing, but it's not at all clear what the right thing is and there should be 
little wonder that it went awry.

I guess from now on we should take those checks more seriously.

We also need to improve the procedure for keeping track of history, as the 
current procedure does not work well at all. We're better off than we were when 
ChangeLog files were maintained by hand in parallel with commit messages, but 
the by-hand maintenance of ChangeLog.2 is still too much trouble. I've proposed 
a way to improve this but to be honest I'd rather just dump the by-hand 
maintenance entirely and this has meant I'm not motivated to work on the problem.
>From f6c1d42be0798c6dae9a5ab65cc1e0506a444e37 Mon Sep 17 00:00:00 2001
From: Paul Eggert <[email-masked]>
Date: Sun, 31 Jan 2016 12:18:03 -0800
Subject: [PATCH] ; Fix ChangeLog.2 commit ID.

---
 ChangeLog.2 | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/ChangeLog.2 b/ChangeLog.2
index 27c6ce3..5921546 100644
--- a/ChangeLog.2
+++ b/ChangeLog.2
@@ -26338,7 +26338,7 @@
 
 This file records repository revisions from
 commit 9d56a21e6a696ad19ac65c4b405aeca44785884a (exclusive) to
-commit d5195155f9a297dc45a40c9b7175715ffe4f1612 (inclusive).
+commit e6b7b6d89ff9288a49099f041752908b5eb9613e (inclusive).
 See ChangeLog.1 for earlier changes.
 
 ;; Local Variables:
-- 
2.5.0

>From d8d5f401aeb371019ae6b1b8089250d9d7fb3240 Mon Sep 17 00:00:00 2001
From: Paul Eggert <[email-masked]>
Date: Sun, 31 Jan 2016 12:37:11 -0800
Subject: [PATCH] ; Fix ChangeLog.2 commit ID.

---
 ChangeLog.2 | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/ChangeLog.2 b/ChangeLog.2
index c5cba03..12f9834 100644
--- a/ChangeLog.2
+++ b/ChangeLog.2
@@ -28545,7 +28545,7 @@
 
 This file records repository revisions from
 commit 9d56a21e6a696ad19ac65c4b405aeca44785884a (exclusive) to
-commit 3f43da09956b663d92f578e41bcacb8742bb6bba (inclusive).
+commit ffbf163ab5ced1bc464a0034e6abc9a41f5e09c4 (inclusive).
 See ChangeLog.1 for earlier changes.
 
 ;; Local Variables:
-- 
2.5.0